import PyGattBLE as gatt
import ClientAWS
import Utils as utils

TOPIC_TURN_ON_OFF = "CoffeeMachine/TurnOnOff"
TOPIC_SHORT_COFFEE = "CoffeeMachine/ShortCoffee"
TOPIC_LONG_COFFEE = "CoffeeMachine/LongCoffee"
TOPIC_LEVEL_COFFEE = "CoffeeMachine/CoffeeLevel"
TOPIC_LEVEL_WATER = "CoffeeMachine/WaterLevel"
TOPIC_GLASS_POSITION = "CoffeeMachine/GlassPosition"
TOPIC_UPDATE = "CoffeeMachine/Update"
TOPIC_ERROR = "CoffeeMachine/Error"

SEND_OFF = 0x00
SEND_ON = 0x01
SEND_SHORT_COFFEE = 0x02
SEND_LONG_COFFEE = 0x03
SEND_GET_WATER_LEVEL = 0x04
SEND_GET_COFFEE_LEVEL = 0x05
SEND_GET_GLASS_POSITION = 0x06
SEND_UPDATE = 0x07

ON = '1'
OFF = '0'
IOT = "/IoT"
ANDROID = "/Android"

MACHINE_IN_USE = "coffee_in_progress"

client = None

handle = 16

timeoutOnOff = None
timeoutShortCoffee = None
timeoutShortCoffeeInUse = None
timeoutLongCoffeeInUse = None
timeoutLongCoffee = None
timeoutLevelCoffee = None
timeoutLevelWater = None
timeoutGlassPostion = None
timeout = None

coffeeDoing = None

flag_error = 0

def getByteArray(message):
    i = [message]
    data = bytearray(i)
    return data 
   
def turnOnOffCallback(client, userdata, message):

    if message.payload == ON:
        if coffeeDoing is None:
            global timeoutOnOff
            timeoutOnOff = utils.time_thread()
               
            if timeoutOnOff is not None:
                timeoutOnOff.topic(message.topic)
                timeoutOnOff.start() 
                
            print ("turn on coffee maker")
            gatt.write_char(handle, getByteArray(SEND_ON))
        
        else:
            sendOnOff("busy")
            print "coffee maker busy"
        
               
    elif message.payload == OFF:
        if coffeeDoing is None:
            global timeoutOnOff
            timeoutOnOff = utils.time_thread()
               
            if timeoutOnOff is not None:
                timeoutOnOff.topic(message.topic)
                timeoutOnOff.start() 
                
            gatt.write_char(handle, getByteArray(SEND_OFF))
            print ("turn off coffee maker") 
        else:
            sendOnOff("busy")
            print "coffee maker busy"
        
    else:
        global timeout
        
        timeout = utils.time_thread()
        
        if timeout is not None:
            timeout.topic(message.topic)
            timeout.start() 
            
        print ("update coffee machine status")
        gatt.write_char(handle, getByteArray(SEND_UPDATE))
        
        
def sendOnOff(message):
    client.publish(TOPIC_TURN_ON_OFF + IOT, message, 0)
    
def stopTimeoutOnOff():
    global timeoutOnOff
    if timeoutOnOff is not None:
        print "stoping timeout on/off"
        timeoutOnOff.stop()

def shortCoffeeCallback(client, userdata, message):
    global timeoutShortCoffee, timeoutShortCoffeeInUse, coffeeDoing
    
    
        
    if coffeeDoing is None:
        coffeeDoing = 1
        timeoutShortCoffee = utils.time_thread()
        timeoutShortCoffee.setClient(message.payload)
        print timeoutShortCoffee.client
        timeoutShortCoffee.topic(message.topic)
        timeoutShortCoffee.start()
    
        print "Received short coffee"
        gatt.write_char(handle, getByteArray(SEND_SHORT_COFFEE))
        
    else:
        
        timeoutShortCoffeeInUse = message.payload
        sendShortCoffee(MACHINE_IN_USE)
    
def sendShortCoffee(message):
    if message == MACHINE_IN_USE:
    
        client.publish(TOPIC_LONG_COFFEE + IOT, timeoutShortCoffeeInUse, 0)  
    else:
        client.publish(TOPIC_LONG_COFFEE + IOT, message + timeoutShortCoffee.client, 0) 
    
def stopTimeoutShortCoffee():
    global timeoutShortCoffee
    if timeoutShortCoffee is not None:
        print "stoping timeout short coffee"
        timeoutShortCoffee.stop()
          
def longCoffeeCallback(client, userdata, message): 
    global timeoutLongCoffee, timeoutLongCoffeeInUse, coffeeDoing 
    
    
    
    if coffeeDoing is None:
        coffeeDoing = 1
        timeoutLongCoffee = utils.time_thread()
        timeoutLongCoffee.setClient(message.payload)
        print timeoutLongCoffee.client
        timeoutLongCoffee.topic(message.topic)
        timeoutLongCoffee.start()
    
        print "Received short coffee"
        gatt.write_char(handle, getByteArray(SEND_LONG_COFFEE))
        
    else:
        timeoutLongCoffeeInUse = message.payload
        sendLongCoffee(MACHINE_IN_USE)
    

def sendLongCoffee(message):
    if message == MACHINE_IN_USE:
       
        print timeoutLongCoffee.client
        client.publish(TOPIC_LONG_COFFEE + IOT, timeoutLongCoffeeInUse, 0)  
    else:
        client.publish(TOPIC_LONG_COFFEE + IOT, message + timeoutLongCoffee.client, 0)  
    
def stopTimeoutLongCoffee():
    global timeoutLongCoffee
    if timeoutLongCoffee is not None:
        print "stoping timeout long coffee"
        timeoutLongCoffee.stop()
        
def levelCoffeeCallback(client, userdata, message):
    global timeoutLevelCoffee
    timeoutLevelCoffee = utils.time_thread()
    
    if timeoutLevelCoffee is not None:
        timeoutLevelCoffee.topic(message.topic)
        timeoutLevelCoffee.start()  
    
    gatt.write_char(handle, getByteArray(SEND_GET_COFFEE_LEVEL))
    print "Received level coffee"
    
def sendCoffeelevel(level):
    client.publish(TOPIC_LEVEL_COFFEE + IOT, level, 0) 
    
def stopTimeoutLevelCoffee():
    global timeoutLevelCoffee
    if timeoutLevelCoffee is not None:
        print "stoping timeout level coffee"
        timeoutLevelCoffee.stop()
    
def levelWaterCallback(client, userdata, message):
    global timeoutLevelWater
    timeoutLevelWater = utils.time_thread()
    
    if timeoutLevelWater is not None:
        timeoutLevelWater.topic(message.topic)
        timeoutLevelWater.start()  
    
    gatt.write_char(handle, getByteArray(SEND_GET_WATER_LEVEL))    
    print "Received water level"
    
def sendLevelWater(level):
    client.publish(TOPIC_LEVEL_WATER + IOT, level, 0)
    
def stopTimeoutLevelWater():
    global timeoutLevelWater
    if timeoutLevelWater is not None:
        print "stoping timeout water level"
        timeoutLevelWater.stop()
    
def glassPositionCallback(client, userdata, message):
    global timeoutGlassPostion
    timeoutGlassPostion = utils.time_thread()
    
    if timeoutGlassPostion is not None:
        timeoutGlassPostion.topic(message.topic)
        timeoutGlassPostion.start()
    
    gatt.write_char(handle, getByteArray(SEND_GET_GLASS_POSITION))

def sendGlassPostion(position):
    client.publish(TOPIC_GLASS_POSITION + IOT, position, 0) 
    print "Sending glass position"
    
def stopTimeoutGlassPostion():
    global timeoutGlassPostion
    if timeoutGlassPostion is not None:
        print "stoping timeout glass position"
        timeoutGlassPostion.stop()
    
def updateCallback(client, userdata, message):
    global timeout
    timeout = utils.time_thread()
    
    if timeout is not None:
        timeout.topic(message.topic)
        timeout.start()  
    
    gatt.write_char(handle, getByteArray(SEND_UPDATE))
    
        
def sendUpdate(message):
    sendOnOff(message[1]) 
    sendLevelWater(message[2])    
    sendGlassPostion(message[3])
    
    
def sendError(message):
    global coffeeDoing, flag_error
    coffeeDoing = None
    print sendError
    print message
    if(message == "connection_error" or message =="write_char_error"):
        if flag_error == 0:
            flag_error = 1
            print "sending error"
            client.publish(TOPIC_ERROR + IOT, message, 0)
    elif(message == "reconnected"):
        flag_error = 0
        client.publish(TOPIC_ERROR + IOT, message, 0)

def stopTimeout():
    global timeout
    if timeout is not None:
        print "stoping timeout update"
        timeout.stop()


def subscribeTopics(client):
    # Register the client to a topic and callback
       
    client.subscribe(TOPIC_TURN_ON_OFF + ANDROID, 1, turnOnOffCallback)
    client.subscribe(TOPIC_SHORT_COFFEE + ANDROID, 1, shortCoffeeCallback)
    client.subscribe(TOPIC_LONG_COFFEE + ANDROID, 1, longCoffeeCallback)
    client.subscribe(TOPIC_LEVEL_COFFEE + ANDROID, 1, levelCoffeeCallback)
    client.subscribe(TOPIC_LEVEL_WATER + ANDROID, 1, levelWaterCallback)
    client.subscribe(TOPIC_GLASS_POSITION + ANDROID, 1, glassPositionCallback)
    client.subscribe(TOPIC_UPDATE + ANDROID, 1, updateCallback)
    
def createClient():
    
    global client
    client = ClientAWS.createClient()
    
    return client



